--/bin/euos
include misc.e
integer p_sh2,sh_pid,showProc, f1
if platform() = LINUX then
    f1 = 265
else
    f1 = 315
end if
global sequence theprompt theprompt = "[root@localhost]# "
global procedure doprompt()
    if k_write(1,theprompt) then end if
end procedure
function showRoutine()
    object x
    sequence cmds, data
    integer i
    data = k_getTaskData(k_getPid(),1)
    i = data[5]
    cmds = data[4]
    if i > length(cmds) then
	return p_sh2
    end if
    x=k_write(1,cmds[i] & "\n")
    i += 1
    data[5] = i
    k_setTaskData(k_getPid(),1,data)
    return showProc
end function
function split(sequence x)
	sequence s, this
	integer bg
	if x[length(x)] = '&' then
		bg = 1
		x = x[1..length(x)-1]
	else
		bg = 0
	end if
	s = {}
	this = ""
	for i = 1 to length(x) do
		if x[i] != ' ' then
			this &= x[i]
		else
			if length(this) then
				s = append(s,this)
				this = ""
			end if
		end if
	end for
	if length(this) then
		s = append(s,this)
	end if
	return {s,bg}
end function
function sh4()
	sequence data
	object x
	data = k_getTaskData(k_getPid(),1)
	data[2] = ""
	k_setTaskData(k_getPid(),1,data)
	doprompt()
	return p_sh2
end function
function sh3()
	sequence data, cmd
	integer pid
	data = k_getTaskData(k_getPid(),1)
	cmd = data[2]
	if equal(cmd,"exit") then
		return -1
	else
		puts(2,'\n')
		cmd = split(cmd)
		pid = k_exec(cmd[1][1],cmd[1][2..length(cmd[1])])
		if pid <= 0 then
			pid = k_write(1, "sh: " & cmd[1][1] & ": command not found.\n")
		else
			if not cmd[2] then
				k_join(pid)
			end if
		end if
	end if
	return routine_id("sh4")
end function
procedure goback()
	object x, junk
	x = k_tell(1)
	if sequence(x) then
		x[2] -= 1
		junk = k_ioctl(1,1,x)
		junk = k_write(1,' ')
		junk = k_ioctl(1,1,x)
	end if
end procedure
function sh2()
	sequence data, cmds
	object x
	sh_pid=k_getPid()
	data = k_getTaskData(k_getPid(),1)
	cmds = data[4]
	x = k_read(data[1],1)
	if sequence(x) then
		if length(x) then
			if x[1]=f1+2 and length(cmds) then -- F3
			    for i = 1 to length(data[2]) do
				goback()
			    end for
			    x=k_write(1,repeat(32,length(data[2])))
			    for i = 1 to length(data[2]) do
				goback()
			    end for
			    data[2]=cmds[length(cmds)]
			    cmds=cmds[1..length(cmds)-1]
			    x=k_write(1,data[2])
			elsif x[1]=f1+6 then -- F7
			    data[5] = 1
			    k_setTaskData(k_getPid(),1,data)
			    return showProc
			elsif x[1]=403 then -- Ctrl+Del
			    for i = 1 to length(data[2]) do
				goback()
			    end for
			    x=k_write(1,repeat(32,length(data[2])))
			    for i = 1 to length(data[2]) do
				goback()
			    end for
			    data[2]=""
			elsif x[1] = 263 or x[1] = 8 then -- Backspace
				if length(data[2]) then
					data[2] = data[2][1..length(data[2])-1]
					goback()
				end if
			elsif x[1] <= 255 then
				data[2] &= x
				x = k_write(1,x)
			end if
		end if
	else
		return -1
	end if
	if length(data[2]) then
		if data[2][length(data[2])] = '\n' or data[2][length(data[2])] = '\r' then
			if length(data[2]) > 1 then
				data[2] = data[2][1..length(data[2])-1]
				cmds = append(cmds,data[2])
				data[4] = cmds
				k_setTaskData(k_getPid(),1,data)
				return routine_id("sh3")
			else
				data[4] = cmds
				k_setTaskData(k_getPid(),1,data)
				return routine_id("sh4")
			end if
		end if
	end if
	data[4] = cmds
	k_setTaskData(k_getPid(),1,data)
	return routine_id("sh2")
end function
p_sh2 = routine_id("sh2")
function sh1()
	sequence cl
	integer f
	cl = k_getCommandLine()
	if length(cl) > 1 then
		f = k_open(cl[2],"rb")
		if f = -1 then
			return -1
		end if
	else
		f = 0
	end if
	k_setTaskData(k_getPid(),1,{f,"",{k_getTaskData(k_getPid(),4),-1},{},0})
	doprompt()
	return routine_id("sh2")
end function
showProc=routine_id("showRoutine")
k_addProgram("sh",{routine_id("sh1"),"Sh",1})
--/bin/euos
include get.e
integer hdl
hdl=1
function foreColor()
    sequence cmd
    cmd=k_getCommandLine()
    cmd=value(cmd[2])
    if cmd[1]=GET_SUCCESS then
	text_color(cmd[2])
    end if
    return -1
end function
function backColor()
    sequence cmd
    cmd=k_getCommandLine()
    cmd=value(cmd[2])
    if cmd[1]=GET_SUCCESS then
	bk_color(cmd[2])
    end if
    return -1
end function
function setMode()
    sequence cmd
    cmd=k_getCommandLine()
    cmd=value(cmd[2])
    if cmd[1]=GET_SUCCESS then
	if find(cmd[2],{1,2}) then
	    hdl=cmd[2]
	else
	    if k_write(2,sprintf("%d is not a valid output handle!\n",cmd[2])) then end if
	end if
    end if
    return -1
end function
function clsMain()
    clear_screen()
    return -1
end function
procedure setEcho(integer v)
    integer pid
    sequence cl
    pid = k_getPid()
    while pid != 0 do
	pid = k_getTaskData(pid, 7)
	cl = k_getTaskData(pid, 2)
	if equal(cl[1],"/bin/sh") then
	    cl = k_getTaskData(pid, 1)
	    if v then
		if k_getTaskData(pid, 4) = cl[3][2] then
		    if k_close(cl[3][2]) then
		    end if
		    cl[2] = -1
		    k_setTaskData(pid, 1, cl)
		end if
		k_setTaskData(pid, 4, cl[3][1])
	    else
		if cl[3][2] = -1 then
		    cl[3][2] = k_open("/dev/null","w")
		    k_setTaskData(pid, 1, cl)
		end if
		k_setTaskData(pid, 4, cl[3][2])
	    end if
	    exit
	end if
    end while
end procedure
function echoMain()
    sequence s,cmd
    cmd=k_getCommandLine()
    if length(cmd) > 1 and equal(cmd[2],"_off") then
	setEcho(0) return -1
    elsif length(cmd) > 1 and equal(cmd[2],"_on") then
	setEcho(1) return -1
    end if
    s=""
    for i = 2 to length(cmd) do
	s &= cmd[i]
	if i < length(cmd) then
	    s &= 32
	end if
    end for
    if k_write(hdl,s&'\n') then end if
    return -1
end function
k_addProgram("echo",{routine_id("echoMain"),"Output echoer",0})
k_addProgram("cls",{routine_id("clsMain"),"cls",0})
k_addProgram("fore",{routine_id("foreColor"),"fgc switch",0})
k_addProgram("back",{routine_id("backColor"),"bgc switch",0})
k_addProgram("outmode",{routine_id("setMode"),"out switch",0})

